#!/bin/sh
#------------------------------------------------------------------------------
# /var/www/htdocs/motion/control/motion-control.cgi - send command to motion deamon on EIS/FAIR
#
# Copyright (c) 2008-2011 The Eisfair Team, team(at)eisfair(dot)org
#
# Creation:     2008-09-14  jed
# Last Update:  $Id: motion-control.cgi 29116 2011-11-14 14:34:37Z jed $
#
# Based on a script initially created by Jeroen Vreeken (pe1rxq@amsat.org)
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version..
#------------------------------------------------------------------------------

# load eislib etc.
. /var/install/include/check-eisfair-version

# set platform specific parameters
case ${EISFAIR_SYSTEM} in
    eisfair-1)
        # eisfair-1
        motionconfig_path=/var/motion
        ;;
    *)
        # default to eisfair-2
        motionconfig_path=/data/packages/motion
        ;;
esac

export WGETRC=${motionconfig_path}/.motion-wgetrc
MOTIONBIN=`grep "^MOTIONBIN" ${motionconfig_path}/motion-cgi.conf | cut -d'=' -f2`
IMAGEDIR=`grep "^IMAGEDIR" ${motionconfig_path}/motion-cgi.conf | cut -d'=' -f 2`
PORT=`grep "^CONTROLPORT" ${motionconfig_path}/motion-cgi.conf | cut -d'=' -f 2`
TMPFILE=/tmp/motion-cgi.$$

ACTION=`echo ${QUERY_STRING} | cut -d'?' -f1`
SOURCE=`echo ${QUERY_STRING} | cut -d'?' -f2`

echo "Content-type: text/html"
echo "max-age: 0"
echo "expires: 0"
echo "pragma: no-cache"
echo "refresh: 10; url="`echo ${REQUEST_URI} | cut -d'?' -f 1`"?${ACTION}?${SOURCE}"
echo

# status | start | pause | snapshot | creatempeg
echo "<HTML>"
echo "<BODY bgcolor=#ffffdd>"

echo "<a href=http://www.lavrsen.dk/twiki/bin/view/Motion/WebHome target=_motion_home><IMG border=0 src=${IMAGEDIR}/motion-tux.gif></a>"
echo "<HR>"
echo "<B>Status:</B>"
echo "<LI>"

# select menu structure based on command
case ${ACTION} in
    'snapshot'|'makemovie' )
        STRUCTURE='action'
        ;;
    * )
        STRUCTURE='detection'
esac

# run request command
wget -O ${TMPFILE} -q http://${SERVER_NAME}:${PORT}/${SOURCE}/${STRUCTURE}/${ACTION}
ret=$?

if [ ${ret} -ne 0 ]
then
    # error runnung wget
    echo "<b>camera-${SOURCE}:</b> Error sending command!"
else
    case ${ACTION} in
        'status' )
            grep -q "status ACTIVE" ${TMPFILE}

            if [ $? -eq 0 ]
            then
                echo "<b>camera-${SOURCE}:</b> Detection status ACTIVE"
            else
                echo "<b>camera-${SOURCE}:</b> Detection status inactive"
            fi
            ;;
        'start' )
            grep -q "Detection resumed" ${TMPFILE}

            if [ $? -eq 0 ]
            then
                echo "<b>camera-${SOURCE}:</b> Detection RESUMED"
            else
                echo "<b>camera-${SOURCE}:</b> Error resuming detection"
            fi
            ;;
        'pause' )
            grep -q "Detection paused" ${TMPFILE}

            if [ $? -eq 0 ]
            then
                echo "<b>camera-${SOURCE}:</b> Detection PAUSED"
            else
                echo "<b>camera-${SOURCE}:</b> Error pausing detection!"
            fi
            ;;
        'snapshot' )
            grep -E -q "snapshot for thread .+ done" ${TMPFILE}

            if [ $? -eq 0 ]
            then
                echo "<b>camera-${SOURCE}:</b> Snapshot DONE"
            else
                echo "<b>camera-${SOURCE}:</b> Error taking snapshot!"
            fi
            ;;
        'creatempeg' )
            grep -E -q "makemovie for thread .+ done" ${TMPFILE}

            if [ $? -eq 0 ]
            then
                echo "<b>camera-${SOURCE}:</b> MPEG creation DONE"
            else
                echo "<b>camera-${SOURCE}:</b> Error creating mpeg movie!"
            fi
            ;;
    esac
fi

rm -f ${TMPFILE}

echo "<HR>"
echo "<P><H6>"
echo "<I>Generated on "`date`" by ${SERVER_NAME}</I><BR>"
echo "(Updated every 10 seconds)"

echo "</BODY>"
echo "</HTML>"
