#!/bin/sh
#------------------------------------------------------------------------------
# /var/www/htdocs/motion/filehandle/motion-filehandle.cgi - cgi-script of
#                                                           motion web gui
#
# Copyright (c) 2008-2011 The Eisfair Team, team(at)eisfair(dot)org
#
# Creation:     2007-09-05  jed
# Last Update:  $Id: motion-filehandle.cgi 29116 2011-11-14 14:34:37Z jed $
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#------------------------------------------------------------------------------

# load eislib etc.
. /var/install/include/check-eisfair-version

#exec 2>/tmp/motion-filehandle-trace-$$.log
#set -x

# set platform specific parameters
case ${EISFAIR_SYSTEM} in
    eisfair-1)
        # eisfair-1
        motionconfig_path=/var/motion
        ;;
    *)
        # default to eisfair-2
        motionconfig_path=/data/packages/motion
        ;;
esac

echo "Content-type: text/html"
echo "Refresh: 0; url=${HTTP_REFERER}"
echo

echo "<HTML>"
echo "<BODY bgcolor=white>"

COMMAND=`echo ${QUERY_STRING} | cut -d'?' -f 1`
ARG=`echo ${QUERY_STRING} | cut -d'?' -f 2-`

ABSOLUTEPATH=`grep "^ABSOLUTEPATH" ${motionconfig_path}/motion-cgi.conf | cut -d'=' -f 2-`
CAMERAPATH=`grep "^CAMERAPATH" ${motionconfig_path}/motion-cgi.conf | cut -d'=' -f 2-`

BREAK="no"

case ${COMMAND} in
    'extract' )
        echo "<B>Extracting: </B><I>$ARG</I><BR>"
        cd ${ABSOLUTEPATH}/${CAMERAPATH}

        if /bin/tar -xzf ${ARG}
        then
            if [ -f ${ARG} ]
            then
                rm -r ${ARG}
            fi
            echo "Done<BR>"
        else
            echo "<P><B>failure!<BR>"
            sleep 3
        fi
        BREAK="yes"
        ;;

    'archive' )
        echo "<B>Archiving: </B><I>${ARG}</I><BR>"
        cd ${ABSOLUTEPATH}/${CAMERAPATH}
        if /bin/tar --remove-files -czf ${ARG}.tgz ${ARG}
        then
            if [ -f ${ARG} ]
            then
                rm -r ${ARG}
            fi
            echo "Done<BR>"
        else
            echo "<P><B>failure!<BR>"
            sleep 3
        fi
        BREAK="yes"
        ;;

    'remove' )
        echo "<B>Removing: </B><I>${ARG}</I><BR>"
        if rm -r ${ABSOLUTEPATH}/${CAMERAPATH}/${ARG}
        then
            echo "Done<BR>"
        else
            echo "<P><B>failure!<BR>"
            sleep 3
        fi
        BREAK="yes"
        ;;
esac

if [ "${BREAK}" = "no" ]
then
    echo "'${COMMAND}' is not a valid command!!!"
fi

echo "</BODY>"
echo "</HTML>"
