#!/bin/sh
#------------------------------------------------------------------------------
# /var/www/htdocs/motion/motion.cgi - main cgi-script of motion web gui
#
# Copyright (c) 2008-2011 The Eisfair Team, team(at)eisfair(dot)org
#
# Creation:     2007-09-05  jed
# Last Update:  $Id: motion.cgi 29116 2011-11-14 14:34:37Z jed $
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#------------------------------------------------------------------------------
# ! If your web-browser displays this text you haven't activated
# ! cgi-script support in your Apache2 configuration. Please read
# ! the paragraph 'Verschiedenes -> Apache2-Konfiguration anpassen'
# ! for further information!
#------------------------------------------------------------------------------

# load eislib etc.
. /var/install/include/check-eisfair-version

# set platform specific parameters
case ${EISFAIR_SYSTEM} in
    eisfair-1)
        # eisfair-1
        motionconfig_path=/var/motion
        ;;
    *)
        # default to eisfair-2
        motionconfig_path=/data/packages/motion
        ;;
esac

SOURCES=''
while read line
do
    echo "${line}" | grep -q "^SOURCE="

    if [ $? -eq 0 ]
    then
        if [ "${SOURCES}" = "" ]
        then
            SOURCES="`echo "${line}" | sed -e 's/ /\&nbsp;/g' -e 's/^SOURCE=//'`"
        else
            SOURCES="${SOURCES} `echo "${line}" | sed -e 's/ /\&nbsp;/g' -e 's/^SOURCE=//'`"
        fi
    fi
done < ${motionconfig_path}/motion-cgi.conf

IMAGEDIR=`grep "^IMAGEDIR" ${motionconfig_path}/motion-cgi.conf | cut -d'=' -f 2`

echo "Content-type: text/html"
echo

echo "<HTML>"
echo "<BODY bgcolor=#ffffdd>"

echo "<a href=http://www.lavrsen.dk/twiki/bin/view/Motion/WebHome target=_motion_home><IMG border=0 src=${IMAGEDIR}/motion-tux.gif></a>"
echo "<HR>"

echo "<B>Available sources:</B>"

for source in ${SOURCES}
do
    echo "<LI>"
    echo ${source} | cut -d'=' -f4
    echo -n "[ <i><a href=motion-tree.cgi?`echo ${source} | cut -d'=' -f1` target=tree_window>Tree</a></i> "

    if [ ! `echo ${source} | cut -d'=' -f1` ==  ${source} ]
    then
        echo -n " | <i><a href=`echo ${source} | cut -d'=' -f2` target=view_window>Live</a></i>"
    fi

    echo "]"
done

echo "<HR>"
echo "<H6>"
echo "motion.cgi is published under the <a href=""http://www.gnu.org"" target=""_top"">GNU</a>"
echo "<a href=""COPYING"" target=view_window>General Public License</a><p>"
echo "<I>Generated on "`date`" by ${SERVER_NAME}"
echo "</H6>"

echo "</BODY>"
echo "</HTML>"
